
/***************************************************************************
                 module classe dta_lfexp.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, August 9, 2011
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{ /*	1	from	nu      		1  i 	j    k
	2	from	dta_lfexp		1  i 	j    k     t-1 
	3	from	dta_lfexp		1  i-1 	j    k     t-1 
 	4	from	dta_lfexp		1  i+1 	j    k     t-1
	5	from	dta_lfexp		1  i 	j-1  k     t-1 
	6	from	dta_lfexp		1  i 	j+1  k     t-1 */
  //  if (Yi==5 && Yj==5)
  //printf("dta_lfil : %d\n",Yt);

  double zbtr = zbtr2(Yi,Yj);
  if(Yt==1){
    double wm12=sqrt(zbtr);//1./(106000.); //1/sqrt(ds1*ds2)
    YS1=wm12*x1;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      double bi   = fsaht_fil * pdth_fil * umask(Yi,Yj,Yk) * ze1ur(Yi,Yj);
      double bim1 = fsaht_fil * pdth_fil * umask(Yi-1,Yj,Yk) * ze1ur(Yi-1,Yj);
      double bj   = fsaht_fil * pdth_fil * vmask(Yi,Yj,Yk) * ze2vr(Yi,Yj);
      double bjm1 = fsaht_fil * pdth_fil * vmask(Yi,Yj-1,Yk) * ze2vr(Yi,Yj-1);

      double tip1,tim1,tjp1,tjm1, tij;
      //cdt au bord i
      if (Yi==1){
	tim1= 0.;
#ifdef K_NEU
	tim1= - bim1 * x2;
#endif
      }
      else{
	tim1= -bim1 * x3;
      }
      if (Yi==NX-2){
	tip1= 0.;
#ifdef K_NEU
	tip1= - bi * x2;
#endif
      }
      else{
	tip1= -bi * x4;
      }
      //cdt au bord j
      if (Yj==1){
	tjm1= 0.;
#ifdef K_NEU
	tjm1= - bjm1 * x2;
#endif
      }
      else{
	tjm1= -bjm1 * x5;
      }
      if (Yj==NY-2){
	tjp1= 0.;
#ifdef K_NEU
	tjp1= - bj * x2;
#endif
      }
      else{
	tjp1= -bj * x6;
      }

      tij= (1./zbtr+bi+bim1+bj+bjm1) * x2;
      YS1 = zbtr*(tip1 + tim1 + tjp1 + tjm1 + tij);
    }
  }
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{
  YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;    YJ1I5=0.;    YJ1I6=0.;
  double zbtr = zbtr2(Yi,Yj);
  if(Yt==1){
    double wm12=sqrt(zbtr);//1./(106000.); //1/sqrt(ds1*ds2)
    YJ1I1=wm12;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;    YJ1I5=0.;    YJ1I6=0.;
    }
    else{
      double bi   = fsaht_fil * pdth_fil * umask(Yi,Yj,Yk) * ze1ur(Yi,Yj);
      double bim1 = fsaht_fil * pdth_fil * umask(Yi-1,Yj,Yk) * ze1ur(Yi-1,Yj);
      double bj   = fsaht_fil * pdth_fil * vmask(Yi,Yj,Yk) * ze2vr(Yi,Yj);
      double bjm1 = fsaht_fil * pdth_fil * vmask(Yi,Yj-1,Yk) * ze2vr(Yi,Yj-1);

      double dtip1_x4=0.,dtim1_x3=0.,dtjp1_x6=0.,dtjm1_x5=0.;
      double dtip1_x2=0.,dtim1_x2=0.,dtjp1_x2=0.,dtjm1_x2=0., dtij_x2=0.;
      //cdt au bord i
      if (Yi==1){
	dtim1_x2= 0.;
#ifdef K_NEU
	dtim1_x2= - bim1;
#endif
      }
      else{
	dtim1_x3= -bim1;
      }
      if (Yi==NX-2){
	dtip1_x2= 0.;
#ifdef K_NEU
	dtip1_x2= - bi;
#endif
      }
      else{
	dtip1_x4= -bi;
      }
      //cdt au bord j
      if (Yj==1){
	dtjm1_x2= 0.;
#ifdef K_NEU
	dtjm1_x2= - bjm1;
#endif
      }
      else{
	dtjm1_x5= -bjm1;
      }
      if (Yj==NY-2){
	dtjp1_x2= 0.;
#ifdef K_NEU
	dtjp1_x2= - bj;
#endif
      }
      else{
	dtjp1_x6= -bj;
      }
      dtij_x2= (1./zbtr+bi+bim1+bj+bjm1);

      YJ1I1 = 0.;
      YJ1I2 = zbtr*(dtip1_x2 + dtim1_x2 + dtjp1_x2 + dtjm1_x2 + dtij_x2);
      YJ1I3 = zbtr*(dtim1_x3);
      YJ1I4 = zbtr*(dtip1_x4);
      YJ1I5 = zbtr*(dtjm1_x5);
      YJ1I6 = zbtr*(dtjp1_x6);
    }
  }
}
