
/***************************************************************************
                 module classe zfuv_UW_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{/*	x1	from	wa			1  i    j    k    t-1
	x2	from	wa			1  i+1  j    k    t-1
	x3	from	wa			1  i    j+1  k    t-1
	x4	from	ua			1  i    j    k	  t-1    
	x5	from	ua			1  i    j    k-1  t-1
	x6	from	va			1  i    j    k	  t-1    
	x7	from	va			1  i    j    k-1  t-1*/

  if(Yt==TU)
    YS1=0.;
  else{
    double zfwij,zfwip1j,zfwijp1;
    /*    if(Yk==0 && Yi==0 && Yj==0)
	  printf("Yt=%d\n",Yt);*/
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
      zfwij=0.25*e1t(Yi,Yj)*e2t(Yi,Yj)*x1;
      zfwip1j=0.25*e1t(Yi+1,Yj)*e2t(Yi+1,Yj)*x2;
      zfwijp1=0.25*e1t(Yi,Yj+1)*e2t(Yi,Yj+1)*x3;
      if(Yk==0){
	YS1=2.*(zfwij+zfwip1j)*x4;
	YS2=2.*(zfwij+zfwijp1)*x6;
      }
      else{
	YS1=(zfwij+zfwip1j)*(x4+x5);
	YS2=(zfwij+zfwijp1)*(x6+x7);
      }
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;   YJ1I5=0.;     YJ1I6=0.;     YJ1I7=0.;
  YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;     YJ2I4=0.;   YJ2I5=0.;     YJ2I6=0.;     YJ2I7=0.;
  if(Yt!=TU){  
    double zfwij,zfwip1j,zfwijp1,dzfwij_x1,dzfwip1j_x2,dzfwijp1_x3;
    /*  if(Yk==0 && Yi==0 && Yj==0)
	printf("Yt=%d\n",Yt);*/
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;     YJ1I4=0.;   YJ1I5=0.;     YJ1I6=0.;     YJ1I7=0.;
      YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;     YJ2I4=0.;   YJ2I5=0.;     YJ2I6=0.;     YJ2I7=0.;
    }
    else{
      zfwij=0.25*e1t(Yi,Yj)*e2t(Yi,Yj)*x1;
      dzfwij_x1=0.25*e1t(Yi,Yj)*e2t(Yi,Yj);
      zfwip1j=0.25*e1t(Yi+1,Yj)*e2t(Yi+1,Yj)*x2;
      dzfwip1j_x2=0.25*e1t(Yi+1,Yj)*e2t(Yi+1,Yj);
      zfwijp1=0.25*e1t(Yi,Yj+1)*e2t(Yi,Yj+1)*x3;
      dzfwijp1_x3=0.25*e1t(Yi,Yj+1)*e2t(Yi,Yj+1);
      if(Yk==0){
	YJ1I1=2.*dzfwij_x1*x4;
	YJ1I2=2.*dzfwip1j_x2*x4;
	YJ1I4=2.*(zfwij+zfwip1j);

	YJ2I1=2.*dzfwij_x1*x6;
	YJ2I3=2.*dzfwijp1_x3*x6;
	YJ2I6=2.*(zfwij+zfwijp1);
      }
      else{
	YJ1I1=dzfwij_x1*(x4+x5);
	YJ1I2=dzfwip1j_x2*(x4+x5);
	YJ1I4=zfwij+zfwip1j;
	YJ1I5=zfwij+zfwip1j;

	YJ2I1=dzfwij_x1*(x6+x7);
	YJ2I3=dzfwijp1_x3*(x6+x7);
	YJ2I6=zfwij+zfwijp1;
	YJ2I7=zfwij+zfwijp1;
      }
    }
    
  }
}
  //===========================================================================
//********************* FIN DU MODULE zfu_UW_dynadv_cen2 **********************
